const { HBDM: EX } = require('../../index.js');
const config = require('../../accounts.config.json');
const assert = require('better-assert');
const debug = require('debug')('log');

const wait = require('delay');
const moment = require('moment');

let ex = new EX({
	Currency: 'ETH',
	BaseCurrency: 'USD',
	ContractType: 'quarter',
	ContractMode: 'All',
	Key: config.hbdm.key,
	Secret: config.hbdm.secret,
	FixedClientId: 12345,
	isWS: false 
});

let ids = {}, stocks = 0, balance = 0, lastPrice = 0;

describe('test hbdm', function() {
	this.timeout(10000000);

	// it('should get markets', async () => {
	// 	console.log(await ex.GetMarkets());
	// });

	// it('should get market', async () => {
	// 	console.log(await ex.GetMarket());
	// });

	// it('should get tickers', async () => {
	// 	console.log(await ex.GetTickers());
	// });

	// it('should wait until websocket ready', () => {
	// 	return ex.waitUntilWSReady();
	// });

	// it('should get ohlc data', async () => {
	// 	console.log(await ex.GetOHLC());
	// 	console.log(await ex.GetOHLC(5, 10));
	// });

	// it('should get public trades', async () => {
	// 	// console.log(await ex.GetPublicTrades());
	// 	// console.log(await ex.GetPublicTrades('ETH'));
	// 	console.log(await ex.GetPublicTrades('BTC', 'USD', 'quarter', 3));
	// });

	// it('should get ticker', async () => {
	// 	let t = await ex.GetTicker();
	// 	debug(t);
	// 	assert(t);
	// 	assert(t.Last && t.Buy && t.Sell && t.Time && t.High && t.Low);
	// 	assert(t.Currency === 'BTC');
	// 	assert(t.BaseCurrency === 'USD');
	// 	assert(t.ContractType === 'this_week');

	// 	t = await ex.GetTicker('ETH', 'USD', 'quarter');
	// 	debug(t);
	// 	assert(t.Currency === 'ETH');
	// 	assert(t.BaseCurrency === 'USD');
	// 	assert(t.ContractType === 'quarter');
	// });
	

	// it('should get records',  async () => {
	// 	let  a = await  ex.GetRecords(5, 'ETH', 'USD', 'this_week');
	// 	console.log(a);
	// });

	// it('should get depth', async () => {
	// 	let t = await ex.GetDepth();
	// 	debug(t);
	// 	assert(t);
	// 	assert(t.Asks && t.Bids);
	// 	assert(t.Asks.length > 0 && t.Bids.length > 0);
	// 	assert(t.Asks[0].Price > 0 && t.Asks[0].Amount > 0);
	// 	assert(t.Bids[0].Price > 0 && t.Bids[0].Amount > 0);
	// 	assert(t.Currency === 'BTC');
	// 	assert(t.BaseCurrency === 'USD');
	// 	assert(t.ContractType === 'this_week');

	// 	t = await ex.GetDepth('ETH', 'USD', 'quarter');
	// 	debug(t);
	// 	assert(t.Asks && t.Bids);
	// 	assert(t.Currency === 'ETH');
	// 	assert(t.BaseCurrency === 'USD');
	// 	assert(t.ContractType === 'quarter');
	// });

	// it('should get account', async () => {
	// 	let t = await ex.GetAccount();
	// 	debug(t);
	// 	assert(t);
	// 	assert(Object.keys(t).indexOf('Stocks') > -1);
	// 	assert(Object.keys(t).indexOf('FrozenStocks') > -1);
	// 	assert(Object.keys(t).indexOf('Balance') > -1);
	// 	assert(Object.keys(t).indexOf('FrozenBalance') > -1);
	// 	assert(t.Currency === 'BTC');
	// 	assert(t.BaseCurrency === 'USD');

	// 	let t2 = await ex.GetAccount('ETH', 'USD');
	// 	debug(t2);
	// 	assert(t2.Currency === 'ETH');
	// 	assert(t2.BaseCurrency === 'USD');
	// });

	// it('should get position', async () => {
	// 	console.log(await ex.GetPosition());
	// 	let oid = await ex.Trade('Short', 110, 1);
	// 	console.log(oid);
	// 	console.log(await ex.GetOrder(oid));
	// 	await wait(1000);
	// 	console.log(await ex.GetOrder(oid));
	// 	await wait(1000);
	// 	console.log(await ex.GetOrder(oid));
	// 	await wait(1000);
	// 	console.log(await ex.GetOrder(oid));
	// 	await wait(1000);
	// 	console.log(await ex.GetOrder(oid));
	// 	await wait(1000);
	// 	console.log(await ex.GetOrder(oid));
	// 	await wait(1000);
	// 	console.log(await ex.GetOrder(oid));
		
	// 	// oid = await ex.Trade('CloseShort', 110, 1);
	// 	// console.log(oid);
	// 	// console.log(await ex.GetOrder(oid));
	// });
	
	// it('should get accounts', async () => {
	// 	let t = await ex.GetAccountsMap();
	// 	console.log(t);
	// });

	// it('should get net position', async () => {
	// 	let t = await ex.GetNetPosition('ETH', 'USD', 'quarter');
	// 	console.log(t);
	// });

	it('should long', async () => {
		let orderId = await ex.Trade('Long', 200, 1);
		debug(orderId);
		assert(orderId);
		await wait(3000);
		console.log(await ex.GetOrder(orderId));
		console.log(await ex.CancelOrder(orderId));
		await wait(1000);
		console.log(await ex.GetOrder(orderId));
	});

	// it('should short', async () => {
	// 	let orderId = await ex.Trade('Short', 6590, 1);
	// 	debug(orderId);
	// 	assert(orderId);
	// 	await wait(3000);
	// 	let orderInfo = await ex.GetOrder(orderId);
	// 	console.log(orderInfo);
	// });


	// it('should short', async () => {
	// 	await ex.Trade('Short', 10000, 1, { Type: 'FOK'});
	// });
	
	
	// it('should get orders', async () => {
	// 	let pendingOrders = await ex.GetOrders();
	// 	console.log(pendingOrders);
	// });
	

	// it('should cancel all pending orders', async () => {
	// 	let re = await ex.CancelPendingOrders();
	// 	debug(re);
	// });


	

	// it('should get trades', async () => {
	// 	let t = 0;
	// 	while ( t < 100 ) {
	// 		try {
	// 			let arr = await ex.GetTrades('BTC', 'USDT');
	// 			arr = arr.filter(o => {
	// 				return !ids[o.Id];
	// 			});

	// 			arr = arr.map(o => {
	// 				ids[o.Id] = true;
	// 				// delete o.Info;
	// 				o.Time = moment(o.Time).format('YYYY-MM-DD HH:mm:ss:SSS');
	// 				return o;
	// 			});

	// 			arr.map(o => {
	// 				if (o.Type === 'Buy') {
	// 					balance -= o.DealAmount * o.AvgPrice;
	// 					stocks += o.DealAmount;
	// 				} else {
	// 					balance += o.DealAmount * o.AvgPrice;
	// 					stocks -= o.DealAmount;
	// 				}
	// 				lastPrice = o.AvgPrice;
	// 			});

	// 			console.log(arr);

	// 			let value = stocks * lastPrice + balance;
	// 			console.log(`stocks = ${stocks} balance = ${balance} value = ${value}`);
	// 		} catch (err) {
	// 			console.error(err);
	// 		}
	// 		await wait(1000);
	// 		t++;
	// 	}
	// });


});