const { KUCOIN: EX } = require('../../index.js');
const config = require('../../accounts.config.json');
const assert = require('better-assert');
const debug = require('debug')('log');

const wait = require('delay');
const moment = require('moment');

let ex = new EX({
	Currency: 'BTC',
	BaseCurrency: 'USDT',
	Key: config.kucoin.key,
	Secret: config.kucoin.secret,
	Pass: config.kucoin.pass,
	isWS: false 
});

let ids = {}, stocks = 0, balance = 0, lastPrice = 0;

describe('test kucoin', function() {
	this.timeout(10000000);

	// it('should wait until websocket ready', () => {
	// 	return ex.waitUntilWSReady();
	// });

	// it('should get tickers', async () => {
	// 	let tickers = await ex.GetTickers();
	// 	console.log(tickers);
	// });

	// it('should get markets', async () => {
	// 	let markets = await ex.GetMarkets();
	// 	markets.map(m => {
	// 		console.log(m.Currency + '_' + m.BaseCurrency, m.Decimals, m.StockDecimals, m.MinTradeAmount);
	// 	});
	// });

	// it('should get MarketsMap', async () => {
	// 	console.log(await ex.GetMarketsMap());
	// });

	// it('should get market info', async () => {
	// 	console.log(await ex.GetMarket('BTC', 'USDT'));
	// 	console.log(await ex.GetMarket('ETH', 'BTC'));
	// });

	// it('should get public trades', async () => {
	// 	console.log(await ex.GetPublicTrades());
	// 	console.log(await ex.GetPublicTrades('ETH', 'BTC'));
	// });

	// it('should get ticker', async () => {
	// 	let t = await ex.GetTicker();
	// 	debug(t);
	// 	assert(t);
	// 	assert(t.Last && t.Buy && t.Sell && t.Time && t.High && t.Low);
	// 	assert(t.Currency === 'BTC');
	// 	assert(t.BaseCurrency === 'USDT');

	// 	t = await ex.GetTicker('EOS', 'USDT');
	// 	debug(t);
	// 	assert(t.Last && t.Buy && t.Sell && t.Time && t.High && t.Low);
	// 	assert(t.Currency === 'EOS');
	// 	assert(t.BaseCurrency === 'USDT');
	// });

	// it('should get depth', async () => {
	// 	let t = await ex.GetDepth();
	// 	debug(t);
	// 	assert(t);
	// 	assert(t.Asks && t.Bids);
	// 	assert(t.Asks.length > 0 && t.Bids.length > 0);
	// 	assert(t.Asks[0].Price > 0 && t.Asks[0].Amount > 0);
	// 	assert(t.Bids[0].Price > 0 && t.Bids[0].Amount > 0);
	// 	assert(t.Currency === 'BTC');
	// 	assert(t.BaseCurrency === 'USDT');

	// 	t = await ex.GetDepth('EOS', 'BTC');
	// 	debug(t);
	// 	assert(t.Asks && t.Bids);
	// 	assert(t.Currency === 'EOS');
	// 	assert(t.BaseCurrency === 'BTC');
	// });

	// it('should get account', async () => {
	// 	let t = await ex.GetAccount();
	// 	console.log(t);
	// });

	// it('should get main account', async () => {
	// 	let t = await ex.GetAccounts('main');
	// 	console.log(t);
	// });

	// it('should get accounts', async () => {
	// 	let a = await ex.GetAccounts();
	// 	debug(a);
	// 	assert(a);
	// 	assert(a[0]);
	// 	assert(a[0].Currency);
	// 	assert(Object.keys(a[0]).indexOf('Free') > -1);
	// 	assert(Object.keys(a[0]).indexOf('Frozen') > -1);
	// });


	// it('should buy', async () => {
	// 	let orderId = await ex.Buy(3999, 0.001);
	// 	debug(orderId);
	// 	assert(orderId);
	// 	await wait(3000);
	// 	let orderInfo = await ex.GetOrder(orderId);
	// 	debug(orderInfo);
		
	// 	debug('cancel order:', await ex.CancelOrder(orderId));

	// 	orderInfo = await ex.GetOrder(orderId);
	// 	debug(orderInfo);
	// });

	// it('should buy', async () => {
	// 	let orderId = await ex.Buy(0.1, 0.01, 'BCH', 'BTC');
	// 	debug(orderId);
	// 	assert(orderId);
	// 	await wait(3000);
	// 	let orderInfo = await ex.GetOrder(orderId, 'BCH', 'BTC');
	// 	debug(orderInfo);
	// 	assert(orderInfo);
	// 	assert(orderInfo.Id);
	// 	assert(orderInfo.Price === 0.1);
	// 	assert(orderInfo.Amount === 0.01);
	// 	assert(orderInfo.DealAmount === 0);
	// 	assert(orderInfo.Type === 'Buy');
	// 	assert(orderInfo.Time);
	// 	assert(orderInfo.Status === 'Pending');
	// 	assert(orderInfo.Currency === 'BCH');
	// 	assert(orderInfo.BaseCurrency === 'BTC');
	// });


	// it('should get orders', async () => {
	// 	let pendingOrders = await ex.GetOrders();
	// 	debug(pendingOrders);
	// 	assert(pendingOrders);
	// 	assert(pendingOrders[0]);
	// 	let orderInfo = pendingOrders[0];
	// 	assert(orderInfo.Id);
	// 	assert(orderInfo.Price === 15);
	// 	assert(orderInfo.Amount === 0.01);
	// 	assert(orderInfo.DealAmount === 0);
	// 	assert(orderInfo.Type === 'Buy');
	// 	assert(orderInfo.Time);
	// 	assert(orderInfo.Status === 'Pending');
	// 	assert(orderInfo.Currency === 'ETC');
	// 	assert(orderInfo.BaseCurrency === 'USDT');
	// });

	// it('should cancel buy order', async () => {
	// 	let a = await ex.GetOrders('BCH', 'BTC');
	// 	debug(a);
	// 	assert(a.length > 0);

	// 	// let re = await ex.CancelOrder(a[0].Id, 'BCH', 'BTC');
	// 	// debug(re);

	// 	let re2 = await ex.CancelPendingOrders('BCH', 'BTC');
	// 	debug(re2);
	// 	await wait(2000);
	// 	let a2 = await ex.GetOrders('BCH', 'BTC');
	// 	debug(a2);
	// 	assert(a2.length === 0);
	// });

	

	// it('should cancel all pending orders', async () => {
	// 	let a = await ex.GetOrders();
	// 	debug(a);
	// 	assert(a.length > 0);

	// 	let re = await ex.CancelPendingOrders();
	// 	debug(re);

	// 	await wait(1000);

	// 	let a2 = await ex.GetOrders();
	// 	debug(a2);
	// 	assert(a2.length === 0);
	// });


	

	it('should get trades', async () => {
		console.log(await ex.GetTrades());
		console.log(await ex.GetTrades('ETH', 'USDT'));
	});


});