const { OKEXV3_SWAP: EX } = require('../../index.js');
const config = require('../../accounts.config.json');
const assert = require('better-assert');
const debug = require('debug')('log');

const wait = require('delay');
const moment = require('moment');

let ex = new EX({
	Currency: 'BCH',
	BaseCurrency: 'USD',
	ContractType: 'this_week',
	ContractMode: 'All',
	Key: config.okexv3_swap.key,
	Secret: config.okexv3_swap.secret,
	Pass: config.okexv3_swap.pass,
	isWS: false 
});

let ids = {}, stocks = 0, balance = 0, lastPrice = 0;

describe('test okex future', function() {
	this.timeout(10000000);

	// it('should get markets', async () => {
	// 	console.log(await ex.GetMarkets());
	// });
	
	it('should get market', async () => {
		console.log(await ex.GetMarket('EOS', 'USD'));
	});

	// it('should get tickers', async () => {
	// 	console.log(await ex.GetTickers());
	// });

	// it('should wait until websocket ready', () => {
	// 	return ex.waitUntilWSReady();
	// });

	// it('should get public trades', async () => {
	// 	console.log(await ex.GetPublicTrades());
	// });

	// it('should get ticker', async () => {
	// 	let t = await ex.GetTicker();
	// 	debug(t);
	// 	assert(t);
	// 	assert(t.Last && t.Buy && t.Sell && t.Time && t.High && t.Low);
	// 	assert(t.Currency === 'BTC');
	// 	assert(t.BaseCurrency === 'USD');
	// 	assert(t.ContractType === 'SWAP');
	// });

	// it('should get depth', async () => {
	// 	let t = await ex.GetDepth();
	// 	console.log(t);
	// });

	// it('should get account', async () => {
	// 	let t = await ex.GetAccount();
	// 	console.log(t);
	// 	debug(t);
	// 	assert(t);
	// 	assert(Object.keys(t).indexOf('Stocks') > -1);
	// 	assert(Object.keys(t).indexOf('FrozenStocks') > -1);
	// 	assert(Object.keys(t).indexOf('Balance') > -1);
	// 	assert(Object.keys(t).indexOf('FrozenBalance') > -1);
	// 	assert(t.Currency === 'BTC');
	// 	assert(t.BaseCurrency === 'USD');
	// });

	// it('should get records', async () => {
	// 	let a = await ex.GetRecords();
	// 	console.log(a.length, a[0], a[a.length -1 ]);
	// });	
	
	// it('should get accounts', async () => {
	// 	let a = await ex.GetAccounts();
	// 	console.log(a);
	// 	assert(a);
	// 	assert(a[0]);
	// 	assert(a[0].Currency);
	// 	assert(Object.keys(a[0]).indexOf('Free') > -1);
	// 	assert(Object.keys(a[0]).indexOf('Frozen') > -1);
	// });

	// it('should get position', async () => {
	// 	let t = await ex.GetPosition();
	// 	debug(t);
	// 	assert(t);
	// });

	// it('should get net position', async () => {
	// 	let t = await ex.GetNetPosition();
	// 	console.log(t);
	// });


	// it('should long', async () => {
	// 	let orderId = await ex.Trade('Long', 3500, 1);
	// 	debug(orderId);
	// 	assert(orderId);
	// 	await wait(300);
	// 	let orderInfo = await ex.GetOrder(orderId);
	// 	console.log(orderInfo);

	// 	console.log(await ex.GetOrders());

	// 	console.log(await ex.CancelOrder(orderId));

	// 	console.log(await ex.GetOrders());
	// 	await wait(3000);

	// 	console.log(await ex.GetOrders());

	// 	console.log(await ex.GetOrder(orderId));

	// });

	// it('should short', async () => {
	// 	let orderId = await ex.Trade('Short', 6590, 1);
	// 	debug(orderId);
	// 	assert(orderId);
	// 	await wait(3000);
	// 	let orderInfo = await ex.GetOrder(orderId);
	// 	console.log(orderInfo);
	// });

	// it('should get orders', async () => {
	// 	let pendingOrders = await ex.GetOrders();
	// 	console.log(pendingOrders);
	// });
	

	// it('should cancel all pending orders', async () => {
	// 	let a = await ex.GetOrders();
	// 	debug(a);
	// 	assert(a.length > 0);

	// 	let re = await ex.CancelPendingOrders();
	// 	debug(re);

	// 	await wait(1000);

	// 	let a2 = await ex.GetOrders();
	// 	debug(a2);
	// 	assert(a2.length === 0);
	// });


	

	// it('should get trades', async () => {
	// 	let t = 0;
	// 	while ( t < 100 ) {
	// 		try {
	// 			let arr = await ex.GetTrades('BTC', 'USDT');
	// 			arr = arr.filter(o => {
	// 				return !ids[o.Id];
	// 			});

	// 			arr = arr.map(o => {
	// 				ids[o.Id] = true;
	// 				// delete o.Info;
	// 				o.Time = moment(o.Time).format('YYYY-MM-DD HH:mm:ss:SSS');
	// 				return o;
	// 			});

	// 			arr.map(o => {
	// 				if (o.Type === 'Buy') {
	// 					balance -= o.DealAmount * o.AvgPrice;
	// 					stocks += o.DealAmount;
	// 				} else {
	// 					balance += o.DealAmount * o.AvgPrice;
	// 					stocks -= o.DealAmount;
	// 				}
	// 				lastPrice = o.AvgPrice;
	// 			});

	// 			console.log(arr);

	// 			let value = stocks * lastPrice + balance;
	// 			console.log(`stocks = ${stocks} balance = ${balance} value = ${value}`);
	// 		} catch (err) {
	// 			console.error(err);
	// 		}
	// 		await wait(1000);
	// 		t++;
	// 	}
	// });


});