const ZB = require('./index.js');
const N = require('precise-number');

class ZB_ACTIVITY extends ZB {

	constructor(options) {
		super(options);
	}

	GetAccount(Currency = '', BaseCurrency = '') {
		if (!Currency) Currency = this.options.Currency;
		if (!BaseCurrency) BaseCurrency = this.options.BaseCurrency;
		return this.rest.GetActivityAccount().then(data => {
			if (!data || !data.data || !data.data.coins) throw new Error("zb GetAccount result error: " + JSON.stringify(data));
			data = data.data;
			let re = {
				Balance: 0,
				FrozenBalance: 0,
				Stocks: 0,
				FrozenStocks: 0,
				Currency,
				BaseCurrency,
			};
			data.coins.map(a => {
				if (a.key === BaseCurrency.toLowerCase()) {
					re.Balance = N.parse(a.available);
					re.FrozenBalance = N.parse(a.freez);
				} else if (a.key.toUpperCase() === Currency) {
					re.Stocks = N.parse(a.available);
					re.FrozenStocks = N.parse(a.freez);
				}

				if (a.key === 'zb') {
					re.ZB = N.parse(a.available);
					re.FrozenZB = N.parse(a.freez);
				}

				if (a.key === 'usdt') {
					re.USDT = N.parse(a.available);
					re.FrozenUSDT = N.parse(a.freez);
				}

				if (a.key === 'qc') {
					re.QC = N.parse(a.available);
					re.FrozenQC = N.parse(a.freez);
				}

				if (a.key === 'pax') {
					re.PAX = N.parse(a.available);
					re.FrozenPAX = N.parse(a.freez);
				}
			});
			re.Info = data;
			return re;
		});
	}

	GetAccounts() {
		return this.rest.GetActivityAccount().then(data => {
			if (!data || !data.data || !data.data.coins) throw new Error("zb GetAccount result error: " + JSON.stringify(data));
			data = data.data;
			let re = [];
			data.coins.map(a => {
				re.push({
					Currency: String(a.key).toUpperCase(),
					Free: N.parse(a.available),
					Frozen: N.parse(a.freez),
					Info: a
				});
			});
			return re;
		});
	}
}


module.exports = ZB_ACTIVITY;