const ExDrivers = require('../');
const { ok } = require('assert');

let ex1 = new ExDrivers.ZB({
	Key: 'a',
	Secret: 'a',
	Pass: 'a',
	Currency: 'BTC',
	BaseCurrency: 'USDT',
	ContractType: 'quarter'
});

let ex2 = new ExDrivers.HBDM({
	Key: 'a',
	Secret: 'a',
	Currency: 'BTC',
	BaseCurrency: 'USD',
	ContractType: 'quarter'
});

(async () => {
	let arr1 = await ex1.GetFixedRecords(5);
	let arr2 = await ex2.GetFixedRecords(5);
	console.log(arr1.length, arr2.length);
	console.log('checking 1');
	checkKline(arr1);
	console.log('checking 2');
	checkKline(arr2);
	console.log(arr1.length, arr2.length);
	console.log(arr1[0]);
	console.log(arr2[0]);
	ok(arr1[0].Time === arr2[0].Time);
	ok(arr1[5].Time === arr2[5].Time);
})();

function checkKline(arr) {
	let gap = arr[1].Time - arr[0].Time;
	for (let i = 1; i < arr.length; i++) {
		let gap2 = arr[i].Time - arr[i - 1].Time;
		if (gap2 !== gap) {
			console.log('error', i);
			console.log(arr[i], arr[i - 1]);
			process.exit();
		}
	}
}